commit:     ee6583aa63ec9dcddf8607c8522fb8530a97e79d
Author:     Marco Leise <marco.leise <AT> gmx <DOT> de>
AuthorDate: Sat May 16 19:57:32 2020 +0000
Commit:     Marco Leise <marco.leise <AT> gmx <DOT> de>
CommitDate: Sat May 16 19:57:32 2020 +0000
URL:        https://gitweb.gentoo.org/repo/user/dlang.git/commit/?id=ee6583aa

ldc2-1.21.0

Signed-off-by: Marco Leise <marco.leise <AT> gmx.de>

 dev-lang/ldc2/Manifest           |  1 +
 dev-lang/ldc2/ldc2-1.21.0.ebuild | 83 ++++++++++++++++++++++++++++++++++++++++
 2 files changed, 84 insertions(+)

diff --git a/dev-lang/ldc2/Manifest b/dev-lang/ldc2/Manifest
index 157e50c..4abf228 100644
--- a/dev-lang/ldc2/Manifest
+++ b/dev-lang/ldc2/Manifest
@@ -4,3 +4,4 @@ DIST ldc-1.17.0-src.tar.gz 7084805 BLAKE2B 
1379ad77c0e489fea43b646a5d6cf5aa54e76
 DIST ldc-1.18.0-src.tar.gz 7183351 BLAKE2B 
0affd49dda5f7c3df64e8d89fe66f2fce4c3a18c4bc5e4147e2e906d10f0b27316c8c460f5b9d767f3f50e5e909448b9f44cb17e156766d5488e237a71dd5009
 SHA512 
fe7529c33d0e43dfb71f474dfa381b88ee476b70933c8f80fc063d9a015df24a75e2b607a7242cc4b9cd4b6ac7559aec8f2883016bf7252342742322fcccbd4d
 DIST ldc-1.19.0-src.tar.gz 7222182 BLAKE2B 
28a2256aad57f5304644126da63d88a9f0e4266402a537b7864605dd5ce97009b87d6767906b4271dd0ec9621bb1fb193531229c4799c66d0b47e6dad91c0766
 SHA512 
ffd1b085c7c8fe76162051234cc73e92f08a391cebac3f405c9dc6d03fcbf459d5e99295066ab4b0bd931bdce84dce53e23c33c1bc8ad35327f1b283f8e8f10a
 DIST ldc-1.20.1-src.tar.gz 7283975 BLAKE2B 
ceb75e767562936606a5fc8383dd089a8daefd04e6fbcd8c6b360fccad50ecb7c6656d60c5351b11a3580d01bdb45101ed50ff6c7a9791af1fd25be160e9a037
 SHA512 
bb699999a69de1773a10998c653b5a1b0bce30e39cfcee0e19b036378b28519b3118ac369b341cfd305a8a9bd904564ffffe83f720a62ab4f2c1942c2e26bb53
+DIST ldc-1.21.0-src.tar.gz 7355981 BLAKE2B 
46f3289e3e39d8c3b2a4985e1de4b5ef0e218188af5095cb2007bb83eec2bdaf6c590786d7b655a1f886c7f46703db2c049cf054c0fac438f943a702d3ac7a3b
 SHA512 
5759cb0ad04d2e62a075748b40efb30261c1ebefbc129024cddccf60ab59c211f20b87a0fe22b0a714a0435f53d54a722229cd8ad4ede7bfbf492809f23c679a

diff --git a/dev-lang/ldc2/ldc2-1.21.0.ebuild b/dev-lang/ldc2/ldc2-1.21.0.ebuild
new file mode 100644
index 0000000..8137ddf
--- /dev/null
+++ b/dev-lang/ldc2/ldc2-1.21.0.ebuild
@@ -0,0 +1,83 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit multilib-build cmake-utils llvm
+
+MY_PV="${PV//_/-}"
+MY_P="ldc-${MY_PV}-src"
+SRC_URI="https://github.com/ldc-developers/ldc/releases/download/v${MY_PV}/${MY_P}.tar.gz";
+S=${WORKDIR}/${MY_P}
+
+DESCRIPTION="LLVM D Compiler"
+HOMEPAGE="https://ldc-developers.github.com/ldc";
+KEYWORDS="~amd64 ~arm ~arm64 ~ppc64 ~x86"
+LICENSE="BSD"
+SLOT="$(ver_cut 1-2)/$(ver_cut 3)"
+
+IUSE="static-libs"
+
+# We support LLVM 3.9 through 10.
+RDEPEND="|| (
+               sys-devel/llvm:10
+               sys-devel/llvm:9
+               sys-devel/llvm:8
+       )
+       <sys-devel/llvm-11:=
+       >=app-eselect/eselect-dlang-20140709"
+DEPEND=">=dev-util/cmake-3.8
+       dev-util/ninja
+       ${RDEPEND}"
+LLVM_MAX_SLOT=10
+PATCHES="${FILESDIR}/ldc2-1.15.0-link-defaultlib-shared.patch"
+
+# For now, we support amd64 multilib. Anyone is free to add more support here.
+MULTILIB_COMPAT=( abi_x86_{32,64} )
+
+DLANG_VERSION_RANGE="2.075-"
+DLANG_PACKAGE_TYPE="single"
+
+inherit dlang
+
+detect_hardened() {
+       gcc --version | grep -o Hardened
+}
+
+src_prepare() {
+       cmake-utils_src_prepare
+}
+
+d_src_configure() {
+       # Make sure libphobos2 is installed into ldc2's directory.
+       export LIBDIR_${ABI}="${LIBDIR_HOST}"
+       local mycmakeargs=(
+               -DD_VERSION=2
+               -DCMAKE_INSTALL_PREFIX=/usr/lib/ldc2/$(ver_cut 1-2)
+               -DD_COMPILER="${DMD}"
+               -DLDC_WITH_LLD=OFF
+       )
+       use static-libs && mycmakeargs+=( -DBUILD_SHARED_LIBS=BOTH ) || 
mycmakeargs+=( -DBUILD_SHARED_LIBS=ON )
+       use abi_x86_32 && use abi_x86_64 && mycmakeargs+=( -DMULTILIB=ON )
+       detect_hardened && mycmakeargs+=( -DADDITIONAL_DEFAULT_LDC_SWITCHES=', 
"-relocation-model=pic"' )
+       cmake-utils_src_configure
+}
+
+d_src_compile() {
+       cmake-utils_src_make
+}
+
+d_src_install() {
+       cmake-utils_src_install
+
+       rm -rf "${ED}"/usr/share/bash-completion
+}
+
+pkg_postinst() {
+       # Update active ldc2
+       "${ROOT}"/usr/bin/eselect dlang update ldc2
+}
+
+pkg_postrm() {
+       "${ROOT}"/usr/bin/eselect dlang update ldc2
+}

Reply via email to